diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
new file mode 100644
index 000000000..7686689ee
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponentLog.java
@@ -0,0 +1,177 @@
+package net.minecraft.client.gui.hud.component;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.console.LogMessage;
+import net.minecraft.client.console.LogMessageReceiver;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.hud.HudIngame;
+import net.minecraft.client.gui.hud.component.layout.Layout;
+import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
+import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.render.Font;
+import net.minecraft.core.net.command.TextFormatting;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.lwjgl.opengl.GL11;
+
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+public class HudComponentLog extends HudComponentMovable {
+    private static final class LogEntry {
+        public final @NotNull String message;
+        public final long addedTime;
+
+        public LogEntry(final @NotNull String message) {
+            this.message = message;
+            this.addedTime = System.currentTimeMillis();
+        }
+
+        public float getOpacity() {
+            final long currentTime = System.currentTimeMillis();
+            final long fadeoutStartTime = this.addedTime + MESSAGE_LIFETIME - MESSAGE_FADE_TIME;
+            if (currentTime < fadeoutStartTime) {
+                return 1.0f;
+            } else {
+                return 1.0f - (float) (currentTime - fadeoutStartTime) / MESSAGE_FADE_TIME;
+            }
+        }
+    }
+
+    private static final int HEIGHT_LINES = 4;
+    private static final int LINE_HEIGHT = 10;
+    private static final int PADDING = 2;
+    private static final int WIDTH = 240;
+    private static final long MESSAGE_LIFETIME = 5000;
+    private static final long MESSAGE_FADE_TIME = 100;
+
+    private final @NotNull Map<LogMessage.@NotNull Level, @NotNull TextFormatting> preludes = new HashMap<>();
+    private final @NotNull List<@NotNull LogEntry> logEntries = new ArrayList<>(HEIGHT_LINES);
+
+    private boolean callbackAdded = false;
+
+    public HudComponentLog(final @NotNull String key, final @NotNull Layout layout) {
+        super(key, PADDING + WIDTH + PADDING, PADDING + HEIGHT_LINES * LINE_HEIGHT + PADDING, layout);
+
+        this.preludes.put(LogMessage.Level.ERROR, TextFormatting.RED);
+        this.preludes.put(LogMessage.Level.WARN, TextFormatting.YELLOW);
+        this.preludes.put(LogMessage.Level.INFO, TextFormatting.WHITE);
+        this.preludes.put(LogMessage.Level.DEBUG, TextFormatting.LIGHT_BLUE);
+        this.preludes.put(LogMessage.Level.TRACE, TextFormatting.GRAY);
+    }
+
+    @Override
+    public boolean isEnabled(final @NotNull Minecraft mc) {
+        return mc.gameSettings.developerMode.value;
+    }
+
+    @Override
+    public boolean isVisible(final @NotNull Minecraft mc) {
+        return true;
+    }
+
+    @Override
+    public void render(final @NotNull Minecraft mc, final @NotNull HudIngame hud, final int xSizeScreen, final int ySizeScreen, final float partialTick) {
+        if (!this.callbackAdded) {
+            LogMessageReceiver.addCallback((message) -> {
+                if (message.getMessage().startsWith("[CHAT] ")) return;
+
+                final @NotNull String ellipsis = "...";
+                final int ellipsisWidth = mc.font.getStringWidth(ellipsis);
+
+                @NotNull String line = message.getMessage().replace("\n", "");
+                int acc = 0;
+                int c = 0;
+                for (; c < line.length(); c++) {
+                    final int cWidth = mc.font.getCharWidth(line.charAt(c));
+                    if (acc + cWidth + ellipsisWidth > WIDTH) {
+                        break;
+                    }
+                    acc += cWidth;
+                }
+                if (c < line.length()) {
+                    line = line.substring(0, c) + ellipsis;
+                }
+
+                if (this.logEntries.size() == HEIGHT_LINES) {
+                    this.logEntries.remove(0);
+                }
+                if (message.getLevel() != null) {
+                    this.logEntries.add(new LogEntry(this.preludes.get(message.getLevel()) + line));
+                } else {
+                    this.logEntries.add(new LogEntry(line));
+                }
+            });
+            callbackAdded = true;
+        }
+
+        int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
+        int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
+
+        // Remove dead entries
+        for (int i = 0; i < this.logEntries.size(); i++) {
+            if (this.logEntries.get(i).getOpacity() <= 0.0f) {
+                this.logEntries.remove(0);
+                i--;
+            }
+        }
+
+        final @NotNull String @NotNull[] messages = new String[this.logEntries.size()];
+        final float @NotNull[] opacities = new float[this.logEntries.size()];
+        for (int i = 0; i < this.logEntries.size(); i++) {
+            messages[i] = this.logEntries.get(i).message;
+            opacities[i] = this.logEntries.get(i).getOpacity();
+        }
+
+        @Nullable ComponentAnchor anchor = null;
+        if (layout instanceof LayoutAbsolute) {
+            anchor = ((LayoutAbsolute) layout).getAnchor();
+        } else if (layout instanceof LayoutSnap) {
+            anchor = ((LayoutSnap) layout).getAnchor();
+        }
+
+        render(mc.font, x, y, messages, opacities, anchor);
+    }
+
+    @Override
+    public void renderPreview(final @NotNull Minecraft mc, final @NotNull Gui gui, final @NotNull Layout layout, final int xSizeScreen, final int ySizeScreen) {
+        int x = layout.getComponentX(mc, this, xSizeScreen);
+        int y = layout.getComponentY(mc, this, ySizeScreen);
+
+        final @NotNull String @NotNull[] lines = {
+            this.preludes.get(LogMessage.Level.DEBUG) + "This is a debug line!",
+            this.preludes.get(LogMessage.Level.INFO) + "This is an info line!",
+            this.preludes.get(LogMessage.Level.WARN) + "This is a warning line!",
+            this.preludes.get(LogMessage.Level.ERROR) + "This is an error line!",
+        };
+
+        @Nullable ComponentAnchor anchor = null;
+        if (layout instanceof LayoutAbsolute) {
+            anchor = ((LayoutAbsolute) layout).getAnchor();
+        } else if (layout instanceof LayoutSnap) {
+            anchor = ((LayoutSnap) layout).getAnchor();
+        }
+
+        render(mc.font, x, y, lines, new float[] { 1.0f, 1.0f, 1.0f, 1.0f }, anchor);
+    }
+
+    private void render(final @NotNull Font font, final int x, final int y, final @NotNull String @NotNull[] lines, final float @NotNull[] opacities, final @Nullable ComponentAnchor anchor) {
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        for (int i = 0; i < lines.length; i++) {
+            @NotNull String line = lines[i];
+
+            final int lineWidth = font.getStringWidth(line);
+            if (anchor == null || anchor == ComponentAnchor.TOP_LEFT || anchor == ComponentAnchor.CENTER_LEFT || anchor == ComponentAnchor.BOTTOM_LEFT) {
+                font.drawStringWithShadow(line, x + PADDING, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+            } else if (anchor == ComponentAnchor.TOP_CENTER || anchor == ComponentAnchor.CENTER || anchor == ComponentAnchor.BOTTOM_CENTER) {
+                font.drawStringWithShadow(line, x + PADDING + WIDTH / 2 - lineWidth / 2, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+            } else {
+                font.drawStringWithShadow(line, x + PADDING + WIDTH - lineWidth, y + PADDING + i * LINE_HEIGHT, 0x00_FF_FF_FF + ((int)(opacities[i] * 0xFF) << 24));
+            }
+        }
+        GL11.glDisable(GL11.GL_BLEND);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
index 4ae51fb46..4573a52df 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponents.java
@@ -66,4 +66,5 @@ public class HudComponents {
     public static final HudComponent FIRE_BAR = register(new HudComponentFireBar("fire_bar", new LayoutSnap(OXYGEN_BAR, ComponentAnchor.TOP_LEFT, ComponentAnchor.BOTTOM_LEFT)));
     public static final HudComponent ROTATION_LOCK = register(new HudComponentRotationLock("rotation_lock", new LayoutSnap(CROSSHAIR, ComponentAnchor.CENTER_RIGHT, ComponentAnchor.CENTER_LEFT)));
     public static final HudComponent SUBTITLES = register(new HubComponentSubtitles("subtitles_box", 100, 50, new LayoutAbsolute(1.0f, 0.75f, ComponentAnchor.BOTTOM_RIGHT)));
+    public static final HudComponent LOG = register(new HudComponentLog("log", new LayoutAbsolute(1.0f, 0.0f, ComponentAnchor.TOP_RIGHT)));
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/keyboard/KeyboardLayout.java b/game/client/src/main/java/net/minecraft/client/gui/keyboard/KeyboardLayout.java
new file mode 100644
index 000000000..1875630ae
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/keyboard/KeyboardLayout.java
@@ -0,0 +1,255 @@
+package net.minecraft.client.gui.keyboard;
+
+import com.google.gson.Gson;
+import com.google.gson.GsonBuilder;
+import com.google.gson.JsonArray;
+import com.google.gson.JsonElement;
+import com.google.gson.JsonObject;
+import com.google.gson.JsonParser;
+import com.google.gson.stream.JsonReader;
+import net.minecraft.client.gui.keyboard.keys.BackspaceKey;
+import net.minecraft.client.gui.keyboard.keys.CharKey;
+import net.minecraft.client.gui.keyboard.keys.CursorKey;
+import net.minecraft.client.gui.keyboard.keys.EnterKey;
+import net.minecraft.client.gui.keyboard.keys.Key;
+import net.minecraft.client.gui.keyboard.keys.GroupKey;
+import net.minecraft.client.gui.keyboard.keys.ModifierKey;
+import net.minecraft.core.lang.I18n;
+
+import java.io.BufferedWriter;
+import java.io.File;
+import java.io.IOException;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.nio.file.Files;
+import java.util.ArrayList;
+import java.util.List;
+
+public class KeyboardLayout {
+    private static final boolean GENERATE_NEW = false;
+    private static final Gson gson = getGson().create();
+
+    // This exists to better facilitate mods adding custom key types
+    private static GsonBuilder getGson() {
+        GsonBuilder builder = new GsonBuilder();
+        builder.setPrettyPrinting();
+        builder.registerTypeAdapter(Key.class, new Key.Serializer());
+        builder.registerTypeAdapter(CharKey.class, new CharKey.Serializer());
+        builder.registerTypeAdapter(GroupKey.class, new GroupKey.Serializer());
+        builder.registerTypeAdapter(CursorKey.class, new CursorKey.Serializer());
+        builder.registerTypeAdapter(EnterKey.class, new EnterKey.Serializer());
+        builder.registerTypeAdapter(BackspaceKey.class, new BackspaceKey.Serializer());
+        builder.registerTypeAdapter(ModifierKey.class, new ModifierKey.Serializer());
+        return builder;
+    }
+
+    public static KeyboardLayout defaultLayout = new KeyboardLayout();
+    private Key[] keys;
+    private int minX;
+    private int maxX;
+    private int minY;
+    private int maxY;
+
+    private int highestGroup = 0;
+
+    private int width;
+    private int height;
+
+    public KeyboardLayout() {
+        loadFromStream(I18n.getResourceAsStream("/lang/en_US/keyboard.json"));
+    }
+
+    private void loadFromStream(InputStream stream) {
+        minX = Integer.MAX_VALUE;
+        maxX = Integer.MIN_VALUE;
+        minY = Integer.MAX_VALUE;
+        maxY = Integer.MIN_VALUE;
+        List<Key> keyList = new ArrayList<>();
+
+        if (GENERATE_NEW) {
+
+            int x = 0;
+            int xShift = 0;
+            int y = 0;
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('1').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('2').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('3').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('4').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('5').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('6').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('7').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('8').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('9').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('0').build());
+            x = 0;
+            xShift = 0;
+            y++;
+
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('q').addGroup('!').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('w').addGroup('@').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'e'}, {'ė'}, {'ę'}, {'ě'}, {'ĕ'}, {'ə'}, {'è'}, {'é'}, {'ê'}, {'ë'}, {'ē'}})
+                .addGroup('#').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'r'}, {'ŕ'}, {'ř'}})
+                .addGroup('$').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'t'}, {'þ'}, {'ť'}, {'ț'}, {'ţ'}})
+                .addGroup('%').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'y'}, {'ý'}})
+                .addGroup('^').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'u'}, {'ų'}, {'ű'}, {'ů'}, {'ū'}, {'ü'}, {'û'}, {'ú'}, {'ù'}})
+                .addGroup('&').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'i'}, {'ı'}, {'į'}, {'ī'}, {'ï'}, {'í'}, {'í'}, {'ì'}})
+                .addGroup('*').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'o'}, {'œ'}, {'ő'}, {'ō'}, {'ø'}, {'ö'}, {'õ'}, {'ô'}, {'ó'}, {'ò'}})
+                .addGroup('(').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('p').addGroup(')').build());
+            x = 0;
+            xShift = 0;
+            y++;
+
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'a'}, {'å'}, {'æ'}, {'ā'}, {'ă'}, {'ą'}, {'ª'}, {'à'}, {'á'}, {'â'}, {'ã'}, {'ä'}})
+                .addGroup('~').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'s'}, {'ß'}, {'ś'}, {'š'}, {'ş'}})
+                .addGroup('\'').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'d'}, {'ď'}, {'đ'}})
+                .addGroup('"').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('f').addGroup('{').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'g'}, {'ģ'}, {'ğ'}})
+                .addGroup('}').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('h').addGroup('[').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('j').addGroup(']').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'k'}, {'ķ'}})
+                .addGroup(':').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'l'}, {'ĺ'}, {'ļ'}, {'ľ'}, {'ł'}})
+                .addGroup(';').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('/').addGroup('\\').build());
+            x = 0;
+            xShift = 0;
+            y++;
+
+            keyList.add(new ModifierKey(18 * x++, 18 * y, 18, 18, ModifierKey.ID_MODIFIER_SHIFT, false).setControllerButton(Key.ButtonEnum.BUTTON_TRIGGER_LEFT));
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'z'}, {'ź'}, {'ż'}, {'ž'}})
+                .addGroup('`').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('x').addGroup('|').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'c'}, {'ç'}, {'ć'}, {'č'}})
+                .addGroup('§').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('v').addGroup('+').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('b').addGroup('-').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y)
+                .addGroup(new char[][]{{'n'}, {'ñ'}, {'ń'}, {'ņ'}, {'ň'}})
+                .addGroup('<').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('m').addGroup('>').build());
+            keyList.add(new CharKey.CharKeyBuilder(18 * x++ + xShift, 18 * y).addGroup('.').addGroup('?').build());
+            keyList.add(new EnterKey(18 * x++ + xShift, 18 * y, 18, 18).setControllerButton(Key.ButtonEnum.BUTTON_START));
+            x = 0;
+            xShift = 0;
+            y++;
+
+            keyList.add(new GroupKey(0, 18 * y, 25, 18, GroupKey.Mode.TOGGLE, 0, 1)
+                .setControllerButton(Key.ButtonEnum.BUTTON_STICK_LEFT)
+                .setTextures(
+                    "minecraft:gui/widgets/keyboard/key_alt/up",
+                    "minecraft:gui/widgets/keyboard/key_alt/down",
+                    "minecraft:gui/widgets/keyboard/key_alt/up_hovered",
+                    "minecraft:gui/widgets/keyboard/key_alt/down_hovered")
+            );
+            keyList.add(
+                new CursorKey(25 + 1, 18 * y, 18, 18, -1)
+                    .setTextures(
+                        GroupKey.Serializer.DEFAULT_TEXTURE_LAST_UP,
+                        GroupKey.Serializer.DEFAULT_TEXTURE_LAST_DOWN,
+                        GroupKey.Serializer.DEFAULT_TEXTURE_LAST_UP_HOVERED,
+                        GroupKey.Serializer.DEFAULT_TEXTURE_LAST_DOWN_HOVERED)
+                    .setControllerButton(Key.ButtonEnum.BUTTON_SHOULDER_LEFT));
+            keyList.add(new CharKey.CharKeyBuilder(25 + 1 + 18 + 1, 18 * y).setWidth(90).addGroup(' ').setButton(Key.ButtonEnum.BUTTON_Y).build());
+            keyList.add(new CursorKey(25 + 1 + 18 + 1 + 90 + 1, 18 * y, 18, 18, 1)
+                .setTextures(
+                    GroupKey.Serializer.DEFAULT_TEXTURE_NEXT_UP,
+                    GroupKey.Serializer.DEFAULT_TEXTURE_NEXT_DOWN,
+                    GroupKey.Serializer.DEFAULT_TEXTURE_NEXT_UP_HOVERED,
+                    GroupKey.Serializer.DEFAULT_TEXTURE_NEXT_DOWN_HOVERED)
+                .setControllerButton(Key.ButtonEnum.BUTTON_SHOULDER_RIGHT));
+            keyList.add(new BackspaceKey(25 + 1 + 18 + 1 + 90 + 1 + 18 + 1, 18 * y, 25, 18).setControllerButton(Key.ButtonEnum.BUTTON_B));
+
+            JsonObject layoutObject = new JsonObject();
+            JsonArray keyArray = new JsonArray(keyList.size());
+            for (Key key : keyList) {
+                keyArray.add(gson.toJsonTree(key));
+            }
+            layoutObject.add("keys", keyArray);
+
+            File out = new File("../core/src/main/resources/lang/en_US/keyboard.json");
+            out.delete();
+            try (BufferedWriter writer = Files.newBufferedWriter(out.toPath())) {
+                out.createNewFile();
+                gson.toJson(layoutObject, writer);
+            } catch (IOException e) {
+                throw new RuntimeException(e);
+            }
+        } else {
+            JsonObject layoutObject = JsonParser.parseReader(new JsonReader(new InputStreamReader(stream))).getAsJsonObject();
+            JsonArray keys = layoutObject.getAsJsonArray("keys");
+            for (JsonElement e : keys) {
+                keyList.add(gson.fromJson(e, Key.class));
+            }
+        }
+
+        keys = keyList.toArray(new Key[0]);
+        for (int i = 0; i < keys.length; i++) {
+            Key key = keys[i];
+            minX = Math.min(minX, key.getX());
+            minY = Math.min(minY, key.getY());
+            maxX = Math.max(maxX, key.getX() + key.getWidth());
+            maxY = Math.max(maxY, key.getY() + key.getHeight());
+            highestGroup = Math.max(highestGroup, key.highestGroup());
+        }
+        width = maxX - minX;
+        height = maxY - minY;
+    }
+
+    public Key[] getKeys() {
+        return keys;
+    }
+
+    public int getMinX() {
+        return minX;
+    }
+
+    public int getMaxX() {
+        return maxX;
+    }
+
+    public int getMinY() {
+        return minY;
+    }
+
+    public int getMaxY() {
+        return maxY;
+    }
+
+    public int getWidth() {
+        return width;
+    }
+
+    public int getHeight() {
+        return height;
+    }
+
+    public int getHighestGroup() {
+        return highestGroup;
+    }
+}
